using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Data;
using Syncfusion.Windows.Forms.Grid;

namespace FormulasInGDBG
{
	/// <summary>
	/// Summary description for Form1.
	/// </summary>
	public class Form1 : System.Windows.Forms.Form
	{
		private Syncfusion.Windows.Forms.Grid.GridControl gridControl1;
		/// <summary>
		/// Required designer variable.
		/// </summary>
		private System.ComponentModel.Container components = null;

		public Form1()
		{
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();

			//
			// TODO: Add any constructor code after InitializeComponent call
			//
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if (components != null) 
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			this.gridControl1 = new Syncfusion.Windows.Forms.Grid.GridControl();
			((System.ComponentModel.ISupportInitialize)(this.gridControl1)).BeginInit();
			this.SuspendLayout();
			// 
			// gridControl1
			// 
			this.gridControl1.Location = new System.Drawing.Point(40, 24);
			this.gridControl1.Name = "gridControl1";
			this.gridControl1.SerializeCellsBehavior = Syncfusion.Windows.Forms.Grid.GridSerializeCellsBehavior.SerializeAsRangeStylesIntoCode;
			this.gridControl1.Size = new System.Drawing.Size(528, 392);
			this.gridControl1.SmartSizeBox = false;
			this.gridControl1.TabIndex = 1;
			this.gridControl1.Text = "gridControl1";
			// 
			// Form1
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.ClientSize = new System.Drawing.Size(616, 446);
			this.Controls.Add(this.gridControl1);
			this.Name = "Form1";
			this.Text = "Form1";
			this.Load += new System.EventHandler(this.Form1_Load);
			((System.ComponentModel.ISupportInitialize)(this.gridControl1)).EndInit();
			this.ResumeLayout(false);

		}
		#endregion

		/// <summary>
		/// The main entry point for the application.
		/// </summary>
		[STAThread]
		static void Main() 
		{
			Application.Run(new Form1());
		}


		private ArrayList formulaTags;
		private DataTable dt;
		private DataTable formulaTable;

		private void Form1_Load(object sender, System.EventArgs e)
		{
			
			dt = new DataTable("MyTable");
						
			int nRows = 10;

			dt.Columns.Add(new DataColumn("Col1", typeof(string)));
			dt.Columns.Add(new DataColumn("Col2", typeof(string)));
			dt.Columns.Add(new DataColumn("formula", typeof(string)));

			for(int i = 0; i < nRows; ++i)
			{
				DataRow dr = dt.NewRow();
				dr[0] = (double) (2 * i);
				dr[1] = (double) i;
				dr[2] = (double) (i * 3);
				dt.Rows.Add(dr);
			}

			#region Formula Cell Table.

			formulaTable = new DataTable("MyFormulaTable");
			
			formulaTable.Columns.Add(new DataColumn("Col1", typeof(string)));
			formulaTable.Columns.Add(new DataColumn("Col2", typeof(string)));
			formulaTable.Columns.Add(new DataColumn("formula", typeof(string)));

			DataRow row = formulaTable.NewRow(); 
			row[0]= "=Sum(A3:A12)";
			row[1]= "=Sum(B3:B12)";
			row[2]= "=Sum(C3:C12)";
			formulaTable.Rows.Add(row);
			formulaTable.AcceptChanges(); 

			#endregion 

			#region Formula Tag.....


			//Maintain formulaTags for the cells
			formulaTags = new ArrayList();

			for(int i = 0; i <= dt.Columns.Count + 1; ++i)
			{
				formulaTags.Add(null);
			}

			#endregion
			

			this.gridControl1.AllowSelection = GridSelectionFlags.Any ^ GridSelectionFlags.Column;  
			this.gridControl1.Properties.ColHeaders = false;  
			
			this.gridControl1.QueryCellInfo +=new GridQueryCellInfoEventHandler(gridControl1_QueryCellInfo); 
			this.gridControl1.SaveCellInfo +=new GridSaveCellInfoEventHandler(gridControl1_SaveCellInfo);
			this.gridControl1.QueryColCount +=new GridRowColCountEventHandler(gridControl1_QueryColCount); 
			this.gridControl1.QueryRowCount +=new GridRowColCountEventHandler(gridControl1_QueryRowCount);
			
			this.gridControl1.ResetVolatileData();
			this.gridControl1.Refresh();
		}

		
	
		private void gridControl1_QueryCellInfo(object sender, GridQueryCellInfoEventArgs e)
		{
			if( e.ColIndex > 0 )
			{
				if( e.RowIndex == 1 )
				{
					e.Style.CellType = "FormulaCell";
					e.Style.CellValue = formulaTable.Rows[0][e.ColIndex - 1];
					e.Style.FormulaTag = (GridFormulaTag) this.formulaTags[e.ColIndex];
					e.Style.Enabled = false;
					e.Handled = true;
				}
				else if( e.RowIndex == 2)
				{
					e.Style.CellType = "Header";
					e.Style.BaseStyle = "Header";
					e.Style.Text = GridRangeInfo.GetAlphaLabel(e.ColIndex); 
				}
				else if( e.RowIndex > 2)
				{
					e.Style.CellValue = dt.Rows[e.RowIndex - 3][e.ColIndex - 1]; 
					e.Handled = true;
				}
			}

		}

		
		private void gridControl1_SaveCellInfo(object sender, GridSaveCellInfoEventArgs e)
		{
			if( e.ColIndex > 0  )
			{
				if(e.RowIndex == 0 )
				{
					formulaTags[e.ColIndex] = e.Style.FormulaTag;
					formulaTable.Rows[0][e.ColIndex - 1]= e.Style.CellValue; 
					e.Handled = true;
				}
				else if( e.RowIndex > 2)
				{
					dt.Rows[e.RowIndex - 3][e.ColIndex - 1] = e.Style.CellValue; 
					e.Handled = true;
				}
			}

		}

		private void gridControl1_QueryColCount(object sender, GridRowColCountEventArgs e)
		{
			e.Count = dt.Columns.Count; 
			e.Handled = true;
		}

		private void gridControl1_QueryRowCount(object sender, GridRowColCountEventArgs e)
		{
			e.Count = dt.Rows.Count + 2;
			e.Handled = true;

		}
	}
}